Index: EcnlProtoTool/trunk/mruby-2.1.1/mrbgems/mruby-math/src/math.c
===================================================================
--- EcnlProtoTool/trunk/mruby-1.3.0/mrbgems/mruby-math/src/math.c	(revision 331)
+++ EcnlProtoTool/trunk/mruby-2.1.1/mrbgems/mruby-math/src/math.c	(revision 439)
@@ -5,4 +5,8 @@
 */
 
+#ifdef MRB_WITHOUT_FLOAT
+# error Math conflicts 'MRB_WITHOUT_FLOAT' configuration in your 'build_config.rb'
+#endif
+
 #include <mruby.h>
 #include <mruby/array.h>
@@ -15,6 +19,5 @@
   struct RClass *math = mrb_module_get(mrb, "Math");
   struct RClass *domainerror = mrb_class_get_under(mrb, math, "DomainError");
-  mrb_value str = mrb_str_new_cstr(mrb, func);
-  mrb_raisef(mrb, domainerror, "Numerical argument is out of domain - %S", str);
+  mrb_raisef(mrb, domainerror, "Numerical argument is out of domain - %s", func);
 }
 
@@ -23,6 +26,4 @@
 
 #include <float.h>
-
-#define MATH_TOLERANCE 1E-12
 
 double
@@ -123,5 +124,6 @@
     sum  += term/(2*j+1);
     ++j;
-  } while (fabs(term/sum) > MATH_TOLERANCE);
+    if (sum == 0) break;
+  } while (fabs(term/sum) > DBL_EPSILON);
   return two_sqrtpi*sum;
 }
@@ -156,8 +158,12 @@
     q1 = q2;
     q2 = b/d;
-  } while (fabs(q1-q2)/q2 > MATH_TOLERANCE);
+  } while (fabs(q1-q2)/q2 > DBL_EPSILON);
   return one_sqrtpi*exp(-x*x)*q2;
 }
 
+#endif
+
+#if defined __FreeBSD__ && !defined __FreeBSD_version
+#include <osreldate.h> /* for __FreeBSD_version */
 #endif
 
@@ -487,5 +493,5 @@
 {
   mrb_float x, base;
-  int argc;
+  mrb_int argc;
 
   argc = mrb_get_args(mrb, "f|f", &x, &base);
@@ -658,5 +664,5 @@
 
   mrb_get_args(mrb, "fi", &x, &i);
-  x = ldexp(x, i);
+  x = ldexp(x, (int)i);
 
   return mrb_float_value(mrb, x);
@@ -737,10 +743,4 @@
 #else
   mrb_define_const(mrb, mrb_math, "E", mrb_float_value(mrb, exp(1.0)));
-#endif
-
-#ifdef MRB_USE_FLOAT
-  mrb_define_const(mrb, mrb_math, "TOLERANCE", mrb_float_value(mrb, 1e-5));
-#else
-  mrb_define_const(mrb, mrb_math, "TOLERANCE", mrb_float_value(mrb, 1e-12));
 #endif
 
Index: EcnlProtoTool/trunk/mruby-2.1.1/mrbgems/mruby-math/test/math.rb
===================================================================
--- EcnlProtoTool/trunk/mruby-1.3.0/mrbgems/mruby-math/test/math.rb	(revision 331)
+++ EcnlProtoTool/trunk/mruby-2.1.1/mrbgems/mruby-math/test/math.rb	(revision 439)
@@ -2,44 +2,37 @@
 # Math Test
 
-##
-# Performs fuzzy check for equality on methods returning floats
-# on the basis of the Math::TOLERANCE constant.
-def check_float(a, b)
-  tolerance = Math::TOLERANCE
-  a = a.to_f
-  b = b.to_f
-  if a.finite? and b.finite?
-    (a-b).abs < tolerance
-  else
-    true
+def assert_float_and_int(exp_ary, act_ary)
+  assert('assert_float_and_int') do
+    flo_exp, int_exp, flo_act, int_act = *exp_ary, *act_ary
+    assert_float(flo_exp, flo_act)
+    assert_operator(int_exp, :eql?, int_act)
   end
 end
 
 assert('Math.sin 0') do
-  check_float(Math.sin(0), 0)
+  assert_float(0, Math.sin(0))
 end
 
 assert('Math.sin PI/2') do
-  check_float(Math.sin(Math::PI / 2), 1)
+  assert_float(1, Math.sin(Math::PI / 2))
 end
 
 assert('Math.cos 0') do
-  check_float(Math.cos(0), 1)
+  assert_float(1, Math.cos(0))
 end
 
 assert('Math.cos PI/2') do
-  check_float(Math.cos(Math::PI / 2), 0)
+  assert_float(0, Math.cos(Math::PI / 2))
 end
 
 assert('Math.tan 0') do
-  check_float(Math.tan(0), 0)
+  assert_float(0, Math.tan(0))
 end
 
 assert('Math.tan PI/4') do
-  check_float(Math.tan(Math::PI / 4), 1)
+  assert_float(1, Math.tan(Math::PI / 4))
 end
 
 assert('Fundamental trig identities') do
-  result = true
   N = 13
   N.times do |i|
@@ -49,59 +42,58 @@
     c  = Math.cos(a)
     t  = Math.tan(a)
-    result &= check_float(s, Math.cos(ca))
-    result &= check_float(t, 1 / Math.tan(ca))
-    result &= check_float(s ** 2 + c ** 2, 1)
-    result &= check_float(t ** 2 + 1, (1/c) ** 2)
-    result &= check_float((1/t) ** 2 + 1, (1/s) ** 2)
-  end
-  result
+    assert_float(Math.cos(ca), s)
+    assert_float(1 / Math.tan(ca), t)
+    assert_float(1, s ** 2 + c ** 2)
+    assert_float((1/c) ** 2, t ** 2 + 1)
+    assert_float((1/s) ** 2, (1/t) ** 2 + 1)
+  end
 end
 
 assert('Math.erf 0') do
-  check_float(Math.erf(0), 0)
+  assert_float(0, Math.erf(0))
 end
 
 assert('Math.exp 0') do
-  check_float(Math.exp(0), 1.0)
+  assert_float(1.0, Math.exp(0))
 end
 
 assert('Math.exp 1') do
-  check_float(Math.exp(1), 2.718281828459045)
+  assert_float(2.718281828459045, Math.exp(1))
 end
 
 assert('Math.exp 1.5') do
-  check_float(Math.exp(1.5), 4.4816890703380645)
+  assert_float(4.4816890703380645, Math.exp(1.5))
 end
 
 assert('Math.log 1') do
-  check_float(Math.log(1), 0)
+  assert_float(0, Math.log(1))
 end
 
 assert('Math.log E') do
-  check_float(Math.log(Math::E), 1.0)
+  assert_float(1.0, Math.log(Math::E))
 end
 
 assert('Math.log E**3') do
-  check_float(Math.log(Math::E**3), 3.0)
+  assert_float(3.0, Math.log(Math::E**3))
 end
 
 assert('Math.log2 1') do
-  check_float(Math.log2(1), 0.0)
+  assert_float(0.0, Math.log2(1))
 end
 
 assert('Math.log2 2') do
-  check_float(Math.log2(2), 1.0)
+  assert_float(1.0, Math.log2(2))
 end
 
 assert('Math.log10 1') do
-  check_float(Math.log10(1), 0.0)
+  assert_float(0.0, Math.log10(1))
 end
 
 assert('Math.log10 10') do
-  check_float(Math.log10(10), 1.0)
+  assert_float(1.0, Math.log10(10))
 end
 
 assert('Math.log10 10**100') do
-  check_float(Math.log10(10**100), 100.0)
+  assert_float(100.0, Math.log10(10**100))
 end
 
@@ -109,9 +101,7 @@
   num = [0.0, 1.0, 2.0, 3.0, 4.0]
   sqr = [0, 1, 4, 9, 16]
-  result = true
   sqr.each_with_index do |v,i|
-    result &= check_float(Math.sqrt(v), num[i])
-  end
-  result
+    assert_float(num[i], Math.sqrt(v))
+  end
 end
 
@@ -119,34 +109,131 @@
   num = [-2.0, -1.0, 0.0, 1.0, 2.0]
   cub = [-8, -1, 0, 1, 8]
-  result = true
   cub.each_with_index do |v,i|
-    result &= check_float(Math.cbrt(v), num[i])
-  end
-  result
+    assert_float(num[i], Math.cbrt(v))
+  end
 end
 
 assert('Math.hypot') do
-  check_float(Math.hypot(3, 4), 5.0)
-end
-
-assert('Math.frexp 1234') do
-  n = 1234
-  fraction, exponent = Math.frexp(n)
-  check_float(Math.ldexp(fraction, exponent), n)
+  assert_float(5.0, Math.hypot(3, 4))
 end
 
 assert('Math.erf 1') do
-  check_float(Math.erf(1), 0.842700792949715)
+  assert_float(0.842700792949715, Math.erf(1))
 end
 
 assert('Math.erfc 1') do
-  check_float(Math.erfc(1), 0.157299207050285)
+  assert_float(0.157299207050285, Math.erfc(1))
 end
 
 assert('Math.erf -1') do
-  check_float(Math.erf(-1), -0.8427007929497148)
+  assert_float(-0.8427007929497148, Math.erf(-1))
 end
 
 assert('Math.erfc -1') do
-  check_float(Math.erfc(-1), 1.8427007929497148)
-end
+  assert_float(1.8427007929497148, Math.erfc(-1))
+end
+
+assert('Math.acos') do
+  assert_float(0 * Math::PI / 4, Math.acos( 1.0))
+  assert_float(1 * Math::PI / 4, Math.acos( 1.0 / Math.sqrt(2)))
+  assert_float(2 * Math::PI / 4, Math.acos( 0.0))
+  assert_float(4 * Math::PI / 4, Math.acos(-1.0))
+  assert_raise(Math::DomainError) { Math.acos(+1.1) }
+  assert_raise(Math::DomainError) { Math.acos(-1.1) }
+end
+
+assert('Math.asin') do
+  assert_float( 0 * Math::PI / 4, Math.asin( 0.0))
+  assert_float( 1 * Math::PI / 4, Math.asin( 1.0 / Math.sqrt(2)))
+  assert_float( 2 * Math::PI / 4, Math.asin( 1.0))
+  assert_float(-2 * Math::PI / 4, Math.asin(-1.0))
+  assert_raise(Math::DomainError) { Math.asin(+1.1) }
+  assert_raise(Math::DomainError) { Math.asin(-1.1) }
+  assert_raise(Math::DomainError) { Math.asin(2.0) }
+end
+
+assert('Math.atan') do
+  assert_float( 0 * Math::PI / 4, Math.atan( 0.0))
+  assert_float( 1 * Math::PI / 4, Math.atan( 1.0))
+  assert_float( 2 * Math::PI / 4, Math.atan(1.0 / 0.0))
+  assert_float(-1 * Math::PI / 4, Math.atan(-1.0))
+end
+
+assert('Math.cosh') do
+  assert_float(1, Math.cosh(0))
+  assert_float((Math::E ** 1 + Math::E ** -1) / 2, Math.cosh(1))
+  assert_float((Math::E ** 2 + Math::E ** -2) / 2, Math.cosh(2))
+end
+
+assert('Math.sinh') do
+  assert_float(0, Math.sinh(0))
+  assert_float((Math::E ** 1 - Math::E ** -1) / 2, Math.sinh(1))
+  assert_float((Math::E ** 2 - Math::E ** -2) / 2, Math.sinh(2))
+end
+
+assert('Math.tanh') do
+  assert_float(Math.sinh(0) / Math.cosh(0), Math.tanh(0))
+  assert_float(Math.sinh(1) / Math.cosh(1), Math.tanh(1))
+  assert_float(Math.sinh(2) / Math.cosh(2), Math.tanh(2))
+  assert_float(+1.0, Math.tanh(+1000.0))
+  assert_float(-1.0, Math.tanh(-1000.0))
+end
+
+assert('Math.acosh') do
+  assert_float(0, Math.acosh(1))
+  assert_float(1, Math.acosh((Math::E ** 1 + Math::E ** -1) / 2))
+  assert_float(2, Math.acosh((Math::E ** 2 + Math::E ** -2) / 2))
+  assert_raise(Math::DomainError) { Math.acosh(0.9) }
+  assert_raise(Math::DomainError) { Math.acosh(0) }
+end
+
+assert('Math.asinh') do
+  assert_float(0, Math.asinh(0))
+  assert_float(1, Math.asinh((Math::E ** 1 - Math::E ** -1) / 2))
+  assert_float(2, Math.asinh((Math::E ** 2 - Math::E ** -2) / 2))
+end
+
+assert('Math.atanh') do
+  assert_float(0, Math.atanh(Math.sinh(0) / Math.cosh(0)))
+  assert_float(1, Math.atanh(Math.sinh(1) / Math.cosh(1)))
+  assert_float(2, Math.atanh(Math.sinh(2) / Math.cosh(2)))
+  assert_float(Float::INFINITY, Math.atanh(1))
+  assert_float(-Float::INFINITY, Math.atanh(-1))
+  assert_raise(Math::DomainError) { Math.atanh(+1.1) }
+  assert_raise(Math::DomainError) { Math.atanh(-1.1) }
+end
+
+assert('Math.atan2') do
+  assert_float(+0.0, Math.atan2(+0.0, +0.0))
+  assert_float(-0.0, Math.atan2(-0.0, +0.0))
+  assert_float(+Math::PI, Math.atan2(+0.0, -0.0))
+  assert_float(-Math::PI, Math.atan2(-0.0, -0.0))
+
+  inf = Float::INFINITY
+  expected = 3.0 * Math::PI / 4.0
+  assert_float(+expected, Math.atan2(+inf, -inf))
+  assert_float(-expected, Math.atan2(-inf, -inf))
+  expected = Math::PI / 4.0
+  assert_float(+expected, Math.atan2(+inf, +inf))
+  assert_float(-expected, Math.atan2(-inf, +inf))
+
+  assert_float(0, Math.atan2(0, 1))
+  assert_float(Math::PI / 4, Math.atan2(1, 1))
+  assert_float(Math::PI / 2, Math.atan2(1, 0))
+end
+
+assert('Math.ldexp') do
+  assert_float(0.0, Math.ldexp(0.0, 0.0))
+  assert_float(0.5, Math.ldexp(0.5, 0.0))
+  assert_float(1.0, Math.ldexp(0.5, 1.0))
+  assert_float(2.0, Math.ldexp(0.5, 2.0))
+  assert_float(3.0, Math.ldexp(0.75, 2.0))
+end
+
+assert('Math.frexp') do
+  assert_float_and_int([0.0,  0], Math.frexp(0.0))
+  assert_float_and_int([0.5,  0], Math.frexp(0.5))
+  assert_float_and_int([0.5,  1], Math.frexp(1.0))
+  assert_float_and_int([0.5,  2], Math.frexp(2.0))
+  assert_float_and_int([0.75, 2], Math.frexp(3.0))
+end
